package net.core.editor.roles.diagram.navigator;

import net.core.editor.roles.RoleModel;
import net.core.editor.roles.diagram.edit.parts.AssociationEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.AssociationEdgeSourceNameEditPart;
import net.core.editor.roles.diagram.edit.parts.Attribute2EditPart;
import net.core.editor.roles.diagram.edit.parts.AttributeEditPart;
import net.core.editor.roles.diagram.edit.parts.AttributeNameType2EditPart;
import net.core.editor.roles.diagram.edit.parts.AttributeNameTypeEditPart;
import net.core.editor.roles.diagram.edit.parts.BaseInheritanceEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.BaseTypeEditPart;
import net.core.editor.roles.diagram.edit.parts.BaseTypeNameEditPart;
import net.core.editor.roles.diagram.edit.parts.CollaborationEditPart;
import net.core.editor.roles.diagram.edit.parts.CollaborationNameEditPart;
import net.core.editor.roles.diagram.edit.parts.Method2EditPart;
import net.core.editor.roles.diagram.edit.parts.MethodEditPart;
import net.core.editor.roles.diagram.edit.parts.MethodNameArgumentsReturnType2EditPart;
import net.core.editor.roles.diagram.edit.parts.MethodNameArgumentsReturnTypeEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleInheritanceEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleModelEditPart;
import net.core.editor.roles.diagram.edit.parts.RolePlayEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleTypeEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleTypeNameEditPart;
import net.core.editor.roles.diagram.part.RoleDiagramEditorPlugin;
import net.core.editor.roles.diagram.part.RoleVisualIDRegistry;
import net.core.editor.roles.diagram.providers.RoleElementTypes;
import net.core.editor.roles.diagram.providers.RoleParserProvider;

import org.eclipse.gmf.runtime.common.ui.services.parser.CommonParserHint;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

/**
 * @generated
 */
public class RoleNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		RoleDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put(
						"Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		RoleDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put(
						"Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof RoleNavigatorItem
				&& !isOwnView(((RoleNavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof RoleNavigatorGroup) {
			RoleNavigatorGroup group = (RoleNavigatorGroup) element;
			return RoleDiagramEditorPlugin.getInstance().getBundledImage(
					group.getIcon());
		}

		if (element instanceof RoleNavigatorItem) {
			RoleNavigatorItem navigatorItem = (RoleNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (RoleVisualIDRegistry.getVisualID(view)) {
		case RoleModelEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?http://net.core.editor/1.0?RoleModel", RoleElementTypes.RoleModel_1000); //$NON-NLS-1$
		case BaseTypeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://net.core.editor/1.0?BaseType", RoleElementTypes.BaseType_2007); //$NON-NLS-1$
		case CollaborationEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://net.core.editor/1.0?Collaboration", RoleElementTypes.Collaboration_2008); //$NON-NLS-1$
		case AttributeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://net.core.editor/1.0?Attribute", RoleElementTypes.Attribute_3007); //$NON-NLS-1$
		case MethodEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://net.core.editor/1.0?Method", RoleElementTypes.Method_3008); //$NON-NLS-1$
		case RoleTypeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://net.core.editor/1.0?RoleType", RoleElementTypes.RoleType_3009); //$NON-NLS-1$
		case Attribute2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://net.core.editor/1.0?Attribute", RoleElementTypes.Attribute_3010); //$NON-NLS-1$
		case Method2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://net.core.editor/1.0?Method", RoleElementTypes.Method_3011); //$NON-NLS-1$
		case RolePlayEdgeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://net.core.editor/1.0?RolePlayEdge", RoleElementTypes.RolePlayEdge_4005); //$NON-NLS-1$
		case RoleInheritanceEdgeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://net.core.editor/1.0?RoleInheritanceEdge", RoleElementTypes.RoleInheritanceEdge_4006); //$NON-NLS-1$
		case BaseInheritanceEdgeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://net.core.editor/1.0?BaseInheritanceEdge", RoleElementTypes.BaseInheritanceEdge_4007); //$NON-NLS-1$
		case AssociationEdgeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://net.core.editor/1.0?AssociationEdge", RoleElementTypes.AssociationEdge_4008); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = RoleDiagramEditorPlugin.getInstance()
				.getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null
				&& RoleElementTypes.isKnownElementType(elementType)) {
			image = RoleElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof RoleNavigatorGroup) {
			RoleNavigatorGroup group = (RoleNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof RoleNavigatorItem) {
			RoleNavigatorItem navigatorItem = (RoleNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (RoleVisualIDRegistry.getVisualID(view)) {
		case RoleModelEditPart.VISUAL_ID:
			return getRoleModel_1000Text(view);
		case BaseTypeEditPart.VISUAL_ID:
			return getBaseType_2007Text(view);
		case CollaborationEditPart.VISUAL_ID:
			return getCollaboration_2008Text(view);
		case AttributeEditPart.VISUAL_ID:
			return getAttribute_3007Text(view);
		case MethodEditPart.VISUAL_ID:
			return getMethod_3008Text(view);
		case RoleTypeEditPart.VISUAL_ID:
			return getRoleType_3009Text(view);
		case Attribute2EditPart.VISUAL_ID:
			return getAttribute_3010Text(view);
		case Method2EditPart.VISUAL_ID:
			return getMethod_3011Text(view);
		case RolePlayEdgeEditPart.VISUAL_ID:
			return getRolePlayEdge_4005Text(view);
		case RoleInheritanceEdgeEditPart.VISUAL_ID:
			return getRoleInheritanceEdge_4006Text(view);
		case BaseInheritanceEdgeEditPart.VISUAL_ID:
			return getBaseInheritanceEdge_4007Text(view);
		case AssociationEdgeEditPart.VISUAL_ID:
			return getAssociationEdge_4008Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getRoleModel_1000Text(View view) {
		RoleModel domainModelElement = (RoleModel) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getName();
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 1000); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getBaseType_2007Text(View view) {
		IParser parser = RoleParserProvider.getParser(
				RoleElementTypes.BaseType_2007,
				view.getElement() != null ? view.getElement() : view,
				RoleVisualIDRegistry.getType(BaseTypeNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5014); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getCollaboration_2008Text(View view) {
		IParser parser = RoleParserProvider.getParser(
				RoleElementTypes.Collaboration_2008,
				view.getElement() != null ? view.getElement() : view,
				RoleVisualIDRegistry
						.getType(CollaborationNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5018); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getAttribute_3007Text(View view) {
		IParser parser = RoleParserProvider.getParser(
				RoleElementTypes.Attribute_3007,
				view.getElement() != null ? view.getElement() : view,
				RoleVisualIDRegistry
						.getType(AttributeNameTypeEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5012); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getMethod_3008Text(View view) {
		IParser parser = RoleParserProvider
				.getParser(
						RoleElementTypes.Method_3008,
						view.getElement() != null ? view.getElement() : view,
						RoleVisualIDRegistry
								.getType(MethodNameArgumentsReturnTypeEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5013); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getRoleType_3009Text(View view) {
		IParser parser = RoleParserProvider.getParser(
				RoleElementTypes.RoleType_3009,
				view.getElement() != null ? view.getElement() : view,
				RoleVisualIDRegistry.getType(RoleTypeNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5017); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getAttribute_3010Text(View view) {
		IParser parser = RoleParserProvider.getParser(
				RoleElementTypes.Attribute_3010,
				view.getElement() != null ? view.getElement() : view,
				RoleVisualIDRegistry
						.getType(AttributeNameType2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5015); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getMethod_3011Text(View view) {
		IParser parser = RoleParserProvider
				.getParser(
						RoleElementTypes.Method_3011,
						view.getElement() != null ? view.getElement() : view,
						RoleVisualIDRegistry
								.getType(MethodNameArgumentsReturnType2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5016); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getRolePlayEdge_4005Text(View view) {
		IParser parser = RoleParserProvider.getParser(
				RoleElementTypes.RolePlayEdge_4005,
				view.getElement() != null ? view.getElement() : view,
				CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6006); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getRoleInheritanceEdge_4006Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getBaseInheritanceEdge_4007Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getAssociationEdge_4008Text(View view) {
		IParser parser = RoleParserProvider.getParser(
				RoleElementTypes.AssociationEdge_4008,
				view.getElement() != null ? view.getElement() : view,
				RoleVisualIDRegistry
						.getType(AssociationEdgeSourceNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			RoleDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6007); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return RoleModelEditPart.MODEL_ID.equals(RoleVisualIDRegistry
				.getModelID(view));
	}

}
