package net.core.editor.roles.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import net.core.editor.roles.AssociationEdge;
import net.core.editor.roles.Attribute;
import net.core.editor.roles.BaseInheritanceEdge;
import net.core.editor.roles.BaseType;
import net.core.editor.roles.Collaboration;
import net.core.editor.roles.Method;
import net.core.editor.roles.RoleInheritanceEdge;
import net.core.editor.roles.RoleModel;
import net.core.editor.roles.RoleModelPackage;
import net.core.editor.roles.RolePlayEdge;
import net.core.editor.roles.RoleType;
import net.core.editor.roles.Type;
import net.core.editor.roles.diagram.edit.parts.AssociationEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.Attribute2EditPart;
import net.core.editor.roles.diagram.edit.parts.AttributeEditPart;
import net.core.editor.roles.diagram.edit.parts.BaseInheritanceEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.BaseTypeBaseAttributeCompartmentEditPart;
import net.core.editor.roles.diagram.edit.parts.BaseTypeBaseMethodCompartmentEditPart;
import net.core.editor.roles.diagram.edit.parts.BaseTypeEditPart;
import net.core.editor.roles.diagram.edit.parts.CollaborationEditPart;
import net.core.editor.roles.diagram.edit.parts.CollaborationRoleTypeCompartmentEditPart;
import net.core.editor.roles.diagram.edit.parts.Method2EditPart;
import net.core.editor.roles.diagram.edit.parts.MethodEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleInheritanceEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleModelEditPart;
import net.core.editor.roles.diagram.edit.parts.RolePlayEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleTypeEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleTypeRoleAttributeCompartmentEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleTypeRoleMethodCompartmentEditPart;
import net.core.editor.roles.diagram.providers.RoleElementTypes;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;

/**
 * @generated
 */
public class RoleDiagramUpdater {

	/**
	 * @generated
	 */
	public static List getSemanticChildren(View view) {
		switch (RoleVisualIDRegistry.getVisualID(view)) {
		case BaseTypeBaseAttributeCompartmentEditPart.VISUAL_ID:
			return getBaseTypeBaseAttributeCompartment_7011SemanticChildren(view);
		case BaseTypeBaseMethodCompartmentEditPart.VISUAL_ID:
			return getBaseTypeBaseMethodCompartment_7012SemanticChildren(view);
		case CollaborationRoleTypeCompartmentEditPart.VISUAL_ID:
			return getCollaborationRoleTypeCompartment_7013SemanticChildren(view);
		case RoleTypeRoleAttributeCompartmentEditPart.VISUAL_ID:
			return getRoleTypeRoleAttributeCompartment_7014SemanticChildren(view);
		case RoleTypeRoleMethodCompartmentEditPart.VISUAL_ID:
			return getRoleTypeRoleMethodCompartment_7015SemanticChildren(view);
		case RoleModelEditPart.VISUAL_ID:
			return getRoleModel_1000SemanticChildren(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getBaseTypeBaseAttributeCompartment_7011SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		BaseType modelElement = (BaseType) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getAttributes().iterator(); it
				.hasNext();) {
			Attribute childElement = (Attribute) it.next();
			int visualID = RoleVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == AttributeEditPart.VISUAL_ID) {
				result.add(new RoleNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBaseTypeBaseMethodCompartment_7012SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		BaseType modelElement = (BaseType) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getMethods().iterator(); it.hasNext();) {
			Method childElement = (Method) it.next();
			int visualID = RoleVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == MethodEditPart.VISUAL_ID) {
				result.add(new RoleNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getCollaborationRoleTypeCompartment_7013SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		Collaboration modelElement = (Collaboration) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getRoleTypes().iterator(); it.hasNext();) {
			RoleType childElement = (RoleType) it.next();
			int visualID = RoleVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == RoleTypeEditPart.VISUAL_ID) {
				result.add(new RoleNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getRoleTypeRoleAttributeCompartment_7014SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		RoleType modelElement = (RoleType) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getAttributes().iterator(); it
				.hasNext();) {
			Attribute childElement = (Attribute) it.next();
			int visualID = RoleVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Attribute2EditPart.VISUAL_ID) {
				result.add(new RoleNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getRoleTypeRoleMethodCompartment_7015SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		RoleType modelElement = (RoleType) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getMethods().iterator(); it.hasNext();) {
			Method childElement = (Method) it.next();
			int visualID = RoleVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Method2EditPart.VISUAL_ID) {
				result.add(new RoleNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getRoleModel_1000SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		RoleModel modelElement = (RoleModel) view.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getBaseTypes().iterator(); it.hasNext();) {
			BaseType childElement = (BaseType) it.next();
			int visualID = RoleVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == BaseTypeEditPart.VISUAL_ID) {
				result.add(new RoleNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getCollaborations().iterator(); it
				.hasNext();) {
			Collaboration childElement = (Collaboration) it.next();
			int visualID = RoleVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == CollaborationEditPart.VISUAL_ID) {
				result.add(new RoleNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getContainedLinks(View view) {
		switch (RoleVisualIDRegistry.getVisualID(view)) {
		case RoleModelEditPart.VISUAL_ID:
			return getRoleModel_1000ContainedLinks(view);
		case BaseTypeEditPart.VISUAL_ID:
			return getBaseType_2007ContainedLinks(view);
		case CollaborationEditPart.VISUAL_ID:
			return getCollaboration_2008ContainedLinks(view);
		case AttributeEditPart.VISUAL_ID:
			return getAttribute_3007ContainedLinks(view);
		case MethodEditPart.VISUAL_ID:
			return getMethod_3008ContainedLinks(view);
		case RoleTypeEditPart.VISUAL_ID:
			return getRoleType_3009ContainedLinks(view);
		case Attribute2EditPart.VISUAL_ID:
			return getAttribute_3010ContainedLinks(view);
		case Method2EditPart.VISUAL_ID:
			return getMethod_3011ContainedLinks(view);
		case RolePlayEdgeEditPart.VISUAL_ID:
			return getRolePlayEdge_4005ContainedLinks(view);
		case RoleInheritanceEdgeEditPart.VISUAL_ID:
			return getRoleInheritanceEdge_4006ContainedLinks(view);
		case BaseInheritanceEdgeEditPart.VISUAL_ID:
			return getBaseInheritanceEdge_4007ContainedLinks(view);
		case AssociationEdgeEditPart.VISUAL_ID:
			return getAssociationEdge_4008ContainedLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getIncomingLinks(View view) {
		switch (RoleVisualIDRegistry.getVisualID(view)) {
		case BaseTypeEditPart.VISUAL_ID:
			return getBaseType_2007IncomingLinks(view);
		case CollaborationEditPart.VISUAL_ID:
			return getCollaboration_2008IncomingLinks(view);
		case AttributeEditPart.VISUAL_ID:
			return getAttribute_3007IncomingLinks(view);
		case MethodEditPart.VISUAL_ID:
			return getMethod_3008IncomingLinks(view);
		case RoleTypeEditPart.VISUAL_ID:
			return getRoleType_3009IncomingLinks(view);
		case Attribute2EditPart.VISUAL_ID:
			return getAttribute_3010IncomingLinks(view);
		case Method2EditPart.VISUAL_ID:
			return getMethod_3011IncomingLinks(view);
		case RolePlayEdgeEditPart.VISUAL_ID:
			return getRolePlayEdge_4005IncomingLinks(view);
		case RoleInheritanceEdgeEditPart.VISUAL_ID:
			return getRoleInheritanceEdge_4006IncomingLinks(view);
		case BaseInheritanceEdgeEditPart.VISUAL_ID:
			return getBaseInheritanceEdge_4007IncomingLinks(view);
		case AssociationEdgeEditPart.VISUAL_ID:
			return getAssociationEdge_4008IncomingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutgoingLinks(View view) {
		switch (RoleVisualIDRegistry.getVisualID(view)) {
		case BaseTypeEditPart.VISUAL_ID:
			return getBaseType_2007OutgoingLinks(view);
		case CollaborationEditPart.VISUAL_ID:
			return getCollaboration_2008OutgoingLinks(view);
		case AttributeEditPart.VISUAL_ID:
			return getAttribute_3007OutgoingLinks(view);
		case MethodEditPart.VISUAL_ID:
			return getMethod_3008OutgoingLinks(view);
		case RoleTypeEditPart.VISUAL_ID:
			return getRoleType_3009OutgoingLinks(view);
		case Attribute2EditPart.VISUAL_ID:
			return getAttribute_3010OutgoingLinks(view);
		case Method2EditPart.VISUAL_ID:
			return getMethod_3011OutgoingLinks(view);
		case RolePlayEdgeEditPart.VISUAL_ID:
			return getRolePlayEdge_4005OutgoingLinks(view);
		case RoleInheritanceEdgeEditPart.VISUAL_ID:
			return getRoleInheritanceEdge_4006OutgoingLinks(view);
		case BaseInheritanceEdgeEditPart.VISUAL_ID:
			return getBaseInheritanceEdge_4007OutgoingLinks(view);
		case AssociationEdgeEditPart.VISUAL_ID:
			return getAssociationEdge_4008OutgoingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getRoleModel_1000ContainedLinks(View view) {
		RoleModel modelElement = (RoleModel) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getContainedTypeModelFacetLinks_RolePlayEdge_4005(modelElement));
		result
				.addAll(getContainedTypeModelFacetLinks_RoleInheritanceEdge_4006(modelElement));
		result
				.addAll(getContainedTypeModelFacetLinks_BaseInheritanceEdge_4007(modelElement));
		result
				.addAll(getContainedTypeModelFacetLinks_AssociationEdge_4008(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getBaseType_2007ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getCollaboration_2008ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getAttribute_3007ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getMethod_3008ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getRoleType_3009ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getAttribute_3010ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getMethod_3011ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getRolePlayEdge_4005ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getRoleInheritanceEdge_4006ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getBaseInheritanceEdge_4007ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getAssociationEdge_4008ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getBaseType_2007IncomingLinks(View view) {
		BaseType modelElement = (BaseType) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingTypeModelFacetLinks_RolePlayEdge_4005(
				modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_BaseInheritanceEdge_4007(
				modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_AssociationEdge_4008(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getCollaboration_2008IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getAttribute_3007IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getMethod_3008IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getRoleType_3009IncomingLinks(View view) {
		RoleType modelElement = (RoleType) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingTypeModelFacetLinks_RoleInheritanceEdge_4006(
				modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_AssociationEdge_4008(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAttribute_3010IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getMethod_3011IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getRolePlayEdge_4005IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getRoleInheritanceEdge_4006IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getBaseInheritanceEdge_4007IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getAssociationEdge_4008IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getBaseType_2007OutgoingLinks(View view) {
		BaseType modelElement = (BaseType) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingTypeModelFacetLinks_BaseInheritanceEdge_4007(modelElement));
		result
				.addAll(getOutgoingTypeModelFacetLinks_AssociationEdge_4008(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getCollaboration_2008OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getAttribute_3007OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getMethod_3008OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getRoleType_3009OutgoingLinks(View view) {
		RoleType modelElement = (RoleType) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingTypeModelFacetLinks_RolePlayEdge_4005(modelElement));
		result
				.addAll(getOutgoingTypeModelFacetLinks_RoleInheritanceEdge_4006(modelElement));
		result
				.addAll(getOutgoingTypeModelFacetLinks_AssociationEdge_4008(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getAttribute_3010OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getMethod_3011OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getRolePlayEdge_4005OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getRoleInheritanceEdge_4006OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getBaseInheritanceEdge_4007OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getAssociationEdge_4008OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	private static Collection getContainedTypeModelFacetLinks_RolePlayEdge_4005(
			RoleModel container) {
		Collection result = new LinkedList();
		for (Iterator links = container.getEdges().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof RolePlayEdge) {
				continue;
			}
			RolePlayEdge link = (RolePlayEdge) linkObject;
			if (RolePlayEdgeEditPart.VISUAL_ID != RoleVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			BaseType dst = link.getTarget();
			RoleType src = link.getSource();
			result.add(new RoleLinkDescriptor(src, dst, link,
					RoleElementTypes.RolePlayEdge_4005,
					RolePlayEdgeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getContainedTypeModelFacetLinks_RoleInheritanceEdge_4006(
			RoleModel container) {
		Collection result = new LinkedList();
		for (Iterator links = container.getEdges().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof RoleInheritanceEdge) {
				continue;
			}
			RoleInheritanceEdge link = (RoleInheritanceEdge) linkObject;
			if (RoleInheritanceEdgeEditPart.VISUAL_ID != RoleVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			RoleType dst = link.getTarget();
			RoleType src = link.getSource();
			result.add(new RoleLinkDescriptor(src, dst, link,
					RoleElementTypes.RoleInheritanceEdge_4006,
					RoleInheritanceEdgeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getContainedTypeModelFacetLinks_BaseInheritanceEdge_4007(
			RoleModel container) {
		Collection result = new LinkedList();
		for (Iterator links = container.getEdges().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof BaseInheritanceEdge) {
				continue;
			}
			BaseInheritanceEdge link = (BaseInheritanceEdge) linkObject;
			if (BaseInheritanceEdgeEditPart.VISUAL_ID != RoleVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			BaseType dst = link.getTarget();
			BaseType src = link.getSource();
			result.add(new RoleLinkDescriptor(src, dst, link,
					RoleElementTypes.BaseInheritanceEdge_4007,
					BaseInheritanceEdgeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getContainedTypeModelFacetLinks_AssociationEdge_4008(
			RoleModel container) {
		Collection result = new LinkedList();
		for (Iterator links = container.getEdges().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof AssociationEdge) {
				continue;
			}
			AssociationEdge link = (AssociationEdge) linkObject;
			if (AssociationEdgeEditPart.VISUAL_ID != RoleVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Type dst = link.getTarget();
			Type src = link.getSource();
			result.add(new RoleLinkDescriptor(src, dst, link,
					RoleElementTypes.AssociationEdge_4008,
					AssociationEdgeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingTypeModelFacetLinks_RolePlayEdge_4005(
			BaseType target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() != RoleModelPackage.eINSTANCE
					.getRolePlayEdge_Target()
					|| false == setting.getEObject() instanceof RolePlayEdge) {
				continue;
			}
			RolePlayEdge link = (RolePlayEdge) setting.getEObject();
			if (RolePlayEdgeEditPart.VISUAL_ID != RoleVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			RoleType src = link.getSource();
			result.add(new RoleLinkDescriptor(src, target, link,
					RoleElementTypes.RolePlayEdge_4005,
					RolePlayEdgeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingTypeModelFacetLinks_RoleInheritanceEdge_4006(
			RoleType target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() != RoleModelPackage.eINSTANCE
					.getRoleInheritanceEdge_Target()
					|| false == setting.getEObject() instanceof RoleInheritanceEdge) {
				continue;
			}
			RoleInheritanceEdge link = (RoleInheritanceEdge) setting
					.getEObject();
			if (RoleInheritanceEdgeEditPart.VISUAL_ID != RoleVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			RoleType src = link.getSource();
			result.add(new RoleLinkDescriptor(src, target, link,
					RoleElementTypes.RoleInheritanceEdge_4006,
					RoleInheritanceEdgeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingTypeModelFacetLinks_BaseInheritanceEdge_4007(
			BaseType target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() != RoleModelPackage.eINSTANCE
					.getBaseInheritanceEdge_Target()
					|| false == setting.getEObject() instanceof BaseInheritanceEdge) {
				continue;
			}
			BaseInheritanceEdge link = (BaseInheritanceEdge) setting
					.getEObject();
			if (BaseInheritanceEdgeEditPart.VISUAL_ID != RoleVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			BaseType src = link.getSource();
			result.add(new RoleLinkDescriptor(src, target, link,
					RoleElementTypes.BaseInheritanceEdge_4007,
					BaseInheritanceEdgeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingTypeModelFacetLinks_AssociationEdge_4008(
			Type target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() != RoleModelPackage.eINSTANCE
					.getAssociationEdge_Target()
					|| false == setting.getEObject() instanceof AssociationEdge) {
				continue;
			}
			AssociationEdge link = (AssociationEdge) setting.getEObject();
			if (AssociationEdgeEditPart.VISUAL_ID != RoleVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Type src = link.getSource();
			result.add(new RoleLinkDescriptor(src, target, link,
					RoleElementTypes.AssociationEdge_4008,
					AssociationEdgeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingTypeModelFacetLinks_RolePlayEdge_4005(
			RoleType source) {
		RoleModel container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element
				.eContainer()) {
			if (element instanceof RoleModel) {
				container = (RoleModel) element;
			}
		}
		if (container == null) {
			return Collections.EMPTY_LIST;
		}
		Collection result = new LinkedList();
		for (Iterator links = container.getEdges().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof RolePlayEdge) {
				continue;
			}
			RolePlayEdge link = (RolePlayEdge) linkObject;
			if (RolePlayEdgeEditPart.VISUAL_ID != RoleVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			BaseType dst = link.getTarget();
			RoleType src = link.getSource();
			if (src != source) {
				continue;
			}
			result.add(new RoleLinkDescriptor(src, dst, link,
					RoleElementTypes.RolePlayEdge_4005,
					RolePlayEdgeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingTypeModelFacetLinks_RoleInheritanceEdge_4006(
			RoleType source) {
		RoleModel container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element
				.eContainer()) {
			if (element instanceof RoleModel) {
				container = (RoleModel) element;
			}
		}
		if (container == null) {
			return Collections.EMPTY_LIST;
		}
		Collection result = new LinkedList();
		for (Iterator links = container.getEdges().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof RoleInheritanceEdge) {
				continue;
			}
			RoleInheritanceEdge link = (RoleInheritanceEdge) linkObject;
			if (RoleInheritanceEdgeEditPart.VISUAL_ID != RoleVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			RoleType dst = link.getTarget();
			RoleType src = link.getSource();
			if (src != source) {
				continue;
			}
			result.add(new RoleLinkDescriptor(src, dst, link,
					RoleElementTypes.RoleInheritanceEdge_4006,
					RoleInheritanceEdgeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingTypeModelFacetLinks_BaseInheritanceEdge_4007(
			BaseType source) {
		RoleModel container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element
				.eContainer()) {
			if (element instanceof RoleModel) {
				container = (RoleModel) element;
			}
		}
		if (container == null) {
			return Collections.EMPTY_LIST;
		}
		Collection result = new LinkedList();
		for (Iterator links = container.getEdges().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof BaseInheritanceEdge) {
				continue;
			}
			BaseInheritanceEdge link = (BaseInheritanceEdge) linkObject;
			if (BaseInheritanceEdgeEditPart.VISUAL_ID != RoleVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			BaseType dst = link.getTarget();
			BaseType src = link.getSource();
			if (src != source) {
				continue;
			}
			result.add(new RoleLinkDescriptor(src, dst, link,
					RoleElementTypes.BaseInheritanceEdge_4007,
					BaseInheritanceEdgeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingTypeModelFacetLinks_AssociationEdge_4008(
			Type source) {
		RoleModel container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element
				.eContainer()) {
			if (element instanceof RoleModel) {
				container = (RoleModel) element;
			}
		}
		if (container == null) {
			return Collections.EMPTY_LIST;
		}
		Collection result = new LinkedList();
		for (Iterator links = container.getEdges().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof AssociationEdge) {
				continue;
			}
			AssociationEdge link = (AssociationEdge) linkObject;
			if (AssociationEdgeEditPart.VISUAL_ID != RoleVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Type dst = link.getTarget();
			Type src = link.getSource();
			if (src != source) {
				continue;
			}
			result.add(new RoleLinkDescriptor(src, dst, link,
					RoleElementTypes.AssociationEdge_4008,
					AssociationEdgeEditPart.VISUAL_ID));
		}
		return result;
	}

}
