package net.core.editor.roles.diagram.part;

import net.core.editor.roles.RoleModel;
import net.core.editor.roles.RoleModelPackage;
import net.core.editor.roles.diagram.edit.parts.AssociationEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.AssociationEdgeSourceLowerBoundSourceUEditPart;
import net.core.editor.roles.diagram.edit.parts.AssociationEdgeSourceNameEditPart;
import net.core.editor.roles.diagram.edit.parts.AssociationEdgeTargetLowerBoundTargetUEditPart;
import net.core.editor.roles.diagram.edit.parts.AssociationEdgeTargetNameEditPart;
import net.core.editor.roles.diagram.edit.parts.Attribute2EditPart;
import net.core.editor.roles.diagram.edit.parts.AttributeEditPart;
import net.core.editor.roles.diagram.edit.parts.AttributeNameType2EditPart;
import net.core.editor.roles.diagram.edit.parts.AttributeNameTypeEditPart;
import net.core.editor.roles.diagram.edit.parts.BaseInheritanceEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.BaseTypeBaseAttributeCompartmentEditPart;
import net.core.editor.roles.diagram.edit.parts.BaseTypeBaseMethodCompartmentEditPart;
import net.core.editor.roles.diagram.edit.parts.BaseTypeEditPart;
import net.core.editor.roles.diagram.edit.parts.BaseTypeNameEditPart;
import net.core.editor.roles.diagram.edit.parts.CollaborationEditPart;
import net.core.editor.roles.diagram.edit.parts.CollaborationNameEditPart;
import net.core.editor.roles.diagram.edit.parts.CollaborationRoleTypeCompartmentEditPart;
import net.core.editor.roles.diagram.edit.parts.Method2EditPart;
import net.core.editor.roles.diagram.edit.parts.MethodEditPart;
import net.core.editor.roles.diagram.edit.parts.MethodNameArgumentsReturnType2EditPart;
import net.core.editor.roles.diagram.edit.parts.MethodNameArgumentsReturnTypeEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleInheritanceEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleModelEditPart;
import net.core.editor.roles.diagram.edit.parts.RolePlayEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleTypeEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleTypeNameEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleTypeRoleAttributeCompartmentEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleTypeRoleMethodCompartmentEditPart;
import net.core.editor.roles.diagram.edit.parts.WrappingLabelEditPart;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class RoleVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "net.core.editor.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (RoleModelEditPart.MODEL_ID.equals(view.getType())) {
				return RoleModelEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return net.core.editor.roles.diagram.part.RoleVisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				RoleDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return String.valueOf(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (RoleModelPackage.eINSTANCE.getRoleModel().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((RoleModel) domainElement)) {
			return RoleModelEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = net.core.editor.roles.diagram.part.RoleVisualIDRegistry
				.getModelID(containerView);
		if (!RoleModelEditPart.MODEL_ID.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (RoleModelEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = net.core.editor.roles.diagram.part.RoleVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = RoleModelEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case BaseTypeBaseAttributeCompartmentEditPart.VISUAL_ID:
			if (RoleModelPackage.eINSTANCE.getAttribute().isSuperTypeOf(
					domainElement.eClass())) {
				return AttributeEditPart.VISUAL_ID;
			}
			break;
		case BaseTypeBaseMethodCompartmentEditPart.VISUAL_ID:
			if (RoleModelPackage.eINSTANCE.getMethod().isSuperTypeOf(
					domainElement.eClass())) {
				return MethodEditPart.VISUAL_ID;
			}
			break;
		case CollaborationRoleTypeCompartmentEditPart.VISUAL_ID:
			if (RoleModelPackage.eINSTANCE.getRoleType().isSuperTypeOf(
					domainElement.eClass())) {
				return RoleTypeEditPart.VISUAL_ID;
			}
			break;
		case RoleTypeRoleAttributeCompartmentEditPart.VISUAL_ID:
			if (RoleModelPackage.eINSTANCE.getAttribute().isSuperTypeOf(
					domainElement.eClass())) {
				return Attribute2EditPart.VISUAL_ID;
			}
			break;
		case RoleTypeRoleMethodCompartmentEditPart.VISUAL_ID:
			if (RoleModelPackage.eINSTANCE.getMethod().isSuperTypeOf(
					domainElement.eClass())) {
				return Method2EditPart.VISUAL_ID;
			}
			break;
		case RoleModelEditPart.VISUAL_ID:
			if (RoleModelPackage.eINSTANCE.getBaseType().isSuperTypeOf(
					domainElement.eClass())) {
				return BaseTypeEditPart.VISUAL_ID;
			}
			if (RoleModelPackage.eINSTANCE.getCollaboration().isSuperTypeOf(
					domainElement.eClass())) {
				return CollaborationEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = net.core.editor.roles.diagram.part.RoleVisualIDRegistry
				.getModelID(containerView);
		if (!RoleModelEditPart.MODEL_ID.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (RoleModelEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = net.core.editor.roles.diagram.part.RoleVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = RoleModelEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case BaseTypeEditPart.VISUAL_ID:
			if (BaseTypeNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (BaseTypeBaseAttributeCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (BaseTypeBaseMethodCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case CollaborationEditPart.VISUAL_ID:
			if (CollaborationNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (CollaborationRoleTypeCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case AttributeEditPart.VISUAL_ID:
			if (AttributeNameTypeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MethodEditPart.VISUAL_ID:
			if (MethodNameArgumentsReturnTypeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case RoleTypeEditPart.VISUAL_ID:
			if (RoleTypeNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (RoleTypeRoleAttributeCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (RoleTypeRoleMethodCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Attribute2EditPart.VISUAL_ID:
			if (AttributeNameType2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Method2EditPart.VISUAL_ID:
			if (MethodNameArgumentsReturnType2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case BaseTypeBaseAttributeCompartmentEditPart.VISUAL_ID:
			if (AttributeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case BaseTypeBaseMethodCompartmentEditPart.VISUAL_ID:
			if (MethodEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case CollaborationRoleTypeCompartmentEditPart.VISUAL_ID:
			if (RoleTypeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case RoleTypeRoleAttributeCompartmentEditPart.VISUAL_ID:
			if (Attribute2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case RoleTypeRoleMethodCompartmentEditPart.VISUAL_ID:
			if (Method2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case RoleModelEditPart.VISUAL_ID:
			if (BaseTypeEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (CollaborationEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case RolePlayEdgeEditPart.VISUAL_ID:
			if (WrappingLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case AssociationEdgeEditPart.VISUAL_ID:
			if (AssociationEdgeSourceNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (AssociationEdgeSourceLowerBoundSourceUEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (AssociationEdgeTargetNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (AssociationEdgeTargetLowerBoundTargetUEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (RoleModelPackage.eINSTANCE.getRolePlayEdge().isSuperTypeOf(
				domainElement.eClass())) {
			return RolePlayEdgeEditPart.VISUAL_ID;
		}
		if (RoleModelPackage.eINSTANCE.getRoleInheritanceEdge().isSuperTypeOf(
				domainElement.eClass())) {
			return RoleInheritanceEdgeEditPart.VISUAL_ID;
		}
		if (RoleModelPackage.eINSTANCE.getBaseInheritanceEdge().isSuperTypeOf(
				domainElement.eClass())) {
			return BaseInheritanceEdgeEditPart.VISUAL_ID;
		}
		if (RoleModelPackage.eINSTANCE.getAssociationEdge().isSuperTypeOf(
				domainElement.eClass())) {
			return AssociationEdgeEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(RoleModel element) {
		return true;
	}

}
