package net.core.editor.roles.diagram.providers;

import java.util.HashSet;
import java.util.IdentityHashMap;
import java.util.Map;
import java.util.Set;

import net.core.editor.roles.RoleModelPackage;
import net.core.editor.roles.diagram.edit.parts.AssociationEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.Attribute2EditPart;
import net.core.editor.roles.diagram.edit.parts.AttributeEditPart;
import net.core.editor.roles.diagram.edit.parts.BaseInheritanceEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.BaseTypeEditPart;
import net.core.editor.roles.diagram.edit.parts.CollaborationEditPart;
import net.core.editor.roles.diagram.edit.parts.Method2EditPart;
import net.core.editor.roles.diagram.edit.parts.MethodEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleInheritanceEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleModelEditPart;
import net.core.editor.roles.diagram.edit.parts.RolePlayEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleTypeEditPart;
import net.core.editor.roles.diagram.part.RoleDiagramEditorPlugin;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;

/**
 * @generated
 */
public class RoleElementTypes extends ElementInitializers {

	/**
	 * @generated
	 */
	private RoleElementTypes() {
	}

	/**
	 * @generated
	 */
	private static Map elements;

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static Set KNOWN_ELEMENT_TYPES;

	/**
	 * @generated
	 */
	public static final IElementType RoleModel_1000 = getElementType("net.core.editor.diagram.RoleModel_1000"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType BaseType_2007 = getElementType("net.core.editor.diagram.BaseType_2007"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Collaboration_2008 = getElementType("net.core.editor.diagram.Collaboration_2008"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Attribute_3007 = getElementType("net.core.editor.diagram.Attribute_3007"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Method_3008 = getElementType("net.core.editor.diagram.Method_3008"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType RoleType_3009 = getElementType("net.core.editor.diagram.RoleType_3009"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Attribute_3010 = getElementType("net.core.editor.diagram.Attribute_3010"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType Method_3011 = getElementType("net.core.editor.diagram.Method_3011"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType RolePlayEdge_4005 = getElementType("net.core.editor.diagram.RolePlayEdge_4005"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType RoleInheritanceEdge_4006 = getElementType("net.core.editor.diagram.RoleInheritanceEdge_4006"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType BaseInheritanceEdge_4007 = getElementType("net.core.editor.diagram.BaseInheritanceEdge_4007"); //$NON-NLS-1$
	/**
	 * @generated
	 */
	public static final IElementType AssociationEdge_4008 = getElementType("net.core.editor.diagram.AssociationEdge_4008"); //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(
			ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			EStructuralFeature feature = ((EStructuralFeature) element);
			EClass eContainingClass = feature.getEContainingClass();
			EClassifier eType = feature.getEType();
			if (eContainingClass != null && !eContainingClass.isAbstract()) {
				element = eContainingClass;
			} else if (eType instanceof EClass
					&& !((EClass) eType).isAbstract()) {
				element = eType;
			}
		}
		if (element instanceof EClass) {
			EClass eClass = (EClass) element;
			if (!eClass.isAbstract()) {
				return RoleDiagramEditorPlugin.getInstance()
						.getItemImageDescriptor(
								eClass.getEPackage().getEFactoryInstance()
										.create(eClass));
			}
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (elements == null) {
			elements = new IdentityHashMap();

			elements.put(RoleModel_1000, RoleModelPackage.eINSTANCE
					.getRoleModel());

			elements.put(BaseType_2007, RoleModelPackage.eINSTANCE
					.getBaseType());

			elements.put(Collaboration_2008, RoleModelPackage.eINSTANCE
					.getCollaboration());

			elements.put(Attribute_3007, RoleModelPackage.eINSTANCE
					.getAttribute());

			elements.put(Method_3008, RoleModelPackage.eINSTANCE.getMethod());

			elements.put(RoleType_3009, RoleModelPackage.eINSTANCE
					.getRoleType());

			elements.put(Attribute_3010, RoleModelPackage.eINSTANCE
					.getAttribute());

			elements.put(Method_3011, RoleModelPackage.eINSTANCE.getMethod());

			elements.put(RolePlayEdge_4005, RoleModelPackage.eINSTANCE
					.getRolePlayEdge());

			elements.put(RoleInheritanceEdge_4006, RoleModelPackage.eINSTANCE
					.getRoleInheritanceEdge());

			elements.put(BaseInheritanceEdge_4007, RoleModelPackage.eINSTANCE
					.getBaseInheritanceEdge());

			elements.put(AssociationEdge_4008, RoleModelPackage.eINSTANCE
					.getAssociationEdge());
		}
		return (ENamedElement) elements.get(type);
	}

	/**
	 * @generated
	 */
	private static IElementType getElementType(String id) {
		return ElementTypeRegistry.getInstance().getType(id);
	}

	/**
	 * @generated
	 */
	public static boolean isKnownElementType(IElementType elementType) {
		if (KNOWN_ELEMENT_TYPES == null) {
			KNOWN_ELEMENT_TYPES = new HashSet();
			KNOWN_ELEMENT_TYPES.add(RoleModel_1000);
			KNOWN_ELEMENT_TYPES.add(BaseType_2007);
			KNOWN_ELEMENT_TYPES.add(Collaboration_2008);
			KNOWN_ELEMENT_TYPES.add(Attribute_3007);
			KNOWN_ELEMENT_TYPES.add(Method_3008);
			KNOWN_ELEMENT_TYPES.add(RoleType_3009);
			KNOWN_ELEMENT_TYPES.add(Attribute_3010);
			KNOWN_ELEMENT_TYPES.add(Method_3011);
			KNOWN_ELEMENT_TYPES.add(RolePlayEdge_4005);
			KNOWN_ELEMENT_TYPES.add(RoleInheritanceEdge_4006);
			KNOWN_ELEMENT_TYPES.add(BaseInheritanceEdge_4007);
			KNOWN_ELEMENT_TYPES.add(AssociationEdge_4008);
		}
		return KNOWN_ELEMENT_TYPES.contains(elementType);
	}

	/**
	 * @generated
	 */
	public static IElementType getElementType(int visualID) {
		switch (visualID) {
		case RoleModelEditPart.VISUAL_ID:
			return RoleModel_1000;
		case BaseTypeEditPart.VISUAL_ID:
			return BaseType_2007;
		case CollaborationEditPart.VISUAL_ID:
			return Collaboration_2008;
		case AttributeEditPart.VISUAL_ID:
			return Attribute_3007;
		case MethodEditPart.VISUAL_ID:
			return Method_3008;
		case RoleTypeEditPart.VISUAL_ID:
			return RoleType_3009;
		case Attribute2EditPart.VISUAL_ID:
			return Attribute_3010;
		case Method2EditPart.VISUAL_ID:
			return Method_3011;
		case RolePlayEdgeEditPart.VISUAL_ID:
			return RolePlayEdge_4005;
		case RoleInheritanceEdgeEditPart.VISUAL_ID:
			return RoleInheritanceEdge_4006;
		case BaseInheritanceEdgeEditPart.VISUAL_ID:
			return BaseInheritanceEdge_4007;
		case AssociationEdgeEditPart.VISUAL_ID:
			return AssociationEdge_4008;
		}
		return null;
	}

}
