package net.core.editor.roles.diagram.providers;

import net.core.editor.roles.RoleModelPackage;
import net.core.editor.roles.diagram.edit.parts.AssociationEdgeSourceLowerBoundSourceUEditPart;
import net.core.editor.roles.diagram.edit.parts.AssociationEdgeSourceNameEditPart;
import net.core.editor.roles.diagram.edit.parts.AssociationEdgeTargetLowerBoundTargetUEditPart;
import net.core.editor.roles.diagram.edit.parts.AssociationEdgeTargetNameEditPart;
import net.core.editor.roles.diagram.edit.parts.AttributeNameType2EditPart;
import net.core.editor.roles.diagram.edit.parts.AttributeNameTypeEditPart;
import net.core.editor.roles.diagram.edit.parts.BaseTypeNameEditPart;
import net.core.editor.roles.diagram.edit.parts.CollaborationNameEditPart;
import net.core.editor.roles.diagram.edit.parts.MethodNameArgumentsReturnType2EditPart;
import net.core.editor.roles.diagram.edit.parts.MethodNameArgumentsReturnTypeEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleTypeNameEditPart;
import net.core.editor.roles.diagram.parsers.MessageFormatParser;
import net.core.editor.roles.diagram.part.RoleVisualIDRegistry;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.service.AbstractProvider;
import org.eclipse.gmf.runtime.common.core.service.IOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.GetParserOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParserProvider;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserService;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.parser.ParserHintAdapter;
import org.eclipse.gmf.runtime.notation.View;

/**
 * @generated
 */
public class RoleParserProvider extends AbstractProvider implements
		IParserProvider {

	/**
	 * @generated
	 */
	private IParser baseTypeName_5014Parser;

	/**
	 * @generated
	 */
	private IParser getBaseTypeName_5014Parser() {
		if (baseTypeName_5014Parser == null) {
			EAttribute[] features = new EAttribute[] { RoleModelPackage.eINSTANCE
					.getType_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			baseTypeName_5014Parser = parser;
		}
		return baseTypeName_5014Parser;
	}

	/**
	 * @generated
	 */
	private IParser collaborationName_5018Parser;

	/**
	 * @generated
	 */
	private IParser getCollaborationName_5018Parser() {
		if (collaborationName_5018Parser == null) {
			EAttribute[] features = new EAttribute[] { RoleModelPackage.eINSTANCE
					.getCollaboration_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			collaborationName_5018Parser = parser;
		}
		return collaborationName_5018Parser;
	}

	/**
	 * @generated
	 */
	private IParser attributeNameType_5012Parser;

	/**
	 * @generated
	 */
	private IParser getAttributeNameType_5012Parser() {
		if (attributeNameType_5012Parser == null) {
			EAttribute[] features = new EAttribute[] {
					RoleModelPackage.eINSTANCE.getAttribute_Name(),
					RoleModelPackage.eINSTANCE.getAttribute_Type() };
			MessageFormatParser parser = new MessageFormatParser(features);
			parser.setViewPattern("{0}:{1}"); //$NON-NLS-1$
			parser.setEditorPattern("{0}:{1}"); //$NON-NLS-1$
			parser.setEditPattern("{0}:{1}"); //$NON-NLS-1$
			attributeNameType_5012Parser = parser;
		}
		return attributeNameType_5012Parser;
	}

	/**
	 * @generated
	 */
	private IParser methodNameArgumentsReturnType_5013Parser;

	/**
	 * @generated
	 */
	private IParser getMethodNameArgumentsReturnType_5013Parser() {
		if (methodNameArgumentsReturnType_5013Parser == null) {
			EAttribute[] features = new EAttribute[] {
					RoleModelPackage.eINSTANCE.getMethod_Name(),
					RoleModelPackage.eINSTANCE.getMethod_Arguments(),
					RoleModelPackage.eINSTANCE.getMethod_ReturnType() };
			MessageFormatParser parser = new MessageFormatParser(features);
			parser.setViewPattern("{0}{1}:{2}"); //$NON-NLS-1$
			parser.setEditorPattern("{0}{1}:{2}"); //$NON-NLS-1$
			parser.setEditPattern("{0}{1}:{2}"); //$NON-NLS-1$
			methodNameArgumentsReturnType_5013Parser = parser;
		}
		return methodNameArgumentsReturnType_5013Parser;
	}

	/**
	 * @generated
	 */
	private IParser roleTypeName_5017Parser;

	/**
	 * @generated
	 */
	private IParser getRoleTypeName_5017Parser() {
		if (roleTypeName_5017Parser == null) {
			EAttribute[] features = new EAttribute[] { RoleModelPackage.eINSTANCE
					.getType_Name() };
			MessageFormatParser parser = new MessageFormatParser(features);
			roleTypeName_5017Parser = parser;
		}
		return roleTypeName_5017Parser;
	}

	/**
	 * @generated
	 */
	private IParser attributeNameType_5015Parser;

	/**
	 * @generated
	 */
	private IParser getAttributeNameType_5015Parser() {
		if (attributeNameType_5015Parser == null) {
			EAttribute[] features = new EAttribute[] {
					RoleModelPackage.eINSTANCE.getAttribute_Name(),
					RoleModelPackage.eINSTANCE.getAttribute_Type() };
			MessageFormatParser parser = new MessageFormatParser(features);
			parser.setViewPattern("{0}:{1}"); //$NON-NLS-1$
			parser.setEditorPattern("{0}:{1}"); //$NON-NLS-1$
			parser.setEditPattern("{0}:{1}"); //$NON-NLS-1$
			attributeNameType_5015Parser = parser;
		}
		return attributeNameType_5015Parser;
	}

	/**
	 * @generated
	 */
	private IParser methodNameArgumentsReturnType_5016Parser;

	/**
	 * @generated
	 */
	private IParser getMethodNameArgumentsReturnType_5016Parser() {
		if (methodNameArgumentsReturnType_5016Parser == null) {
			EAttribute[] features = new EAttribute[] {
					RoleModelPackage.eINSTANCE.getMethod_Name(),
					RoleModelPackage.eINSTANCE.getMethod_Arguments(),
					RoleModelPackage.eINSTANCE.getMethod_ReturnType() };
			MessageFormatParser parser = new MessageFormatParser(features);
			parser.setViewPattern("{0}{1}:{2}"); //$NON-NLS-1$
			parser.setEditorPattern("{0}{1}:{2}"); //$NON-NLS-1$
			parser.setEditPattern("{0}{1}:{2}"); //$NON-NLS-1$
			methodNameArgumentsReturnType_5016Parser = parser;
		}
		return methodNameArgumentsReturnType_5016Parser;
	}

	/**
	 * @generated
	 */
	private IParser associationEdgeSourceName_6007Parser;

	/**
	 * @generated
	 */
	private IParser getAssociationEdgeSourceName_6007Parser() {
		if (associationEdgeSourceName_6007Parser == null) {
			EAttribute[] features = new EAttribute[] { RoleModelPackage.eINSTANCE
					.getAssociationEdge_SourceName() };
			MessageFormatParser parser = new MessageFormatParser(features);
			associationEdgeSourceName_6007Parser = parser;
		}
		return associationEdgeSourceName_6007Parser;
	}

	/**
	 * @generated
	 */
	private IParser associationEdgeSourceLowerBoundSourceUpperBound_6008Parser;

	/**
	 * @generated
	 */
	private IParser getAssociationEdgeSourceLowerBoundSourceUpperBound_6008Parser() {
		if (associationEdgeSourceLowerBoundSourceUpperBound_6008Parser == null) {
			EAttribute[] features = new EAttribute[] {
					RoleModelPackage.eINSTANCE
							.getAssociationEdge_SourceLowerBound(),
					RoleModelPackage.eINSTANCE
							.getAssociationEdge_SourceUpperBound() };
			MessageFormatParser parser = new MessageFormatParser(features);
			parser.setViewPattern("{0}..{1}"); //$NON-NLS-1$
			parser.setEditorPattern("{0}..{1}"); //$NON-NLS-1$
			parser.setEditPattern("{0}..{1}"); //$NON-NLS-1$
			associationEdgeSourceLowerBoundSourceUpperBound_6008Parser = parser;
		}
		return associationEdgeSourceLowerBoundSourceUpperBound_6008Parser;
	}

	/**
	 * @generated
	 */
	private IParser associationEdgeTargetName_6009Parser;

	/**
	 * @generated
	 */
	private IParser getAssociationEdgeTargetName_6009Parser() {
		if (associationEdgeTargetName_6009Parser == null) {
			EAttribute[] features = new EAttribute[] { RoleModelPackage.eINSTANCE
					.getAssociationEdge_TargetName() };
			MessageFormatParser parser = new MessageFormatParser(features);
			associationEdgeTargetName_6009Parser = parser;
		}
		return associationEdgeTargetName_6009Parser;
	}

	/**
	 * @generated
	 */
	private IParser associationEdgeTargetLowerBoundTargetUpperBound_6010Parser;

	/**
	 * @generated
	 */
	private IParser getAssociationEdgeTargetLowerBoundTargetUpperBound_6010Parser() {
		if (associationEdgeTargetLowerBoundTargetUpperBound_6010Parser == null) {
			EAttribute[] features = new EAttribute[] {
					RoleModelPackage.eINSTANCE
							.getAssociationEdge_TargetLowerBound(),
					RoleModelPackage.eINSTANCE
							.getAssociationEdge_TargetUpperBound() };
			MessageFormatParser parser = new MessageFormatParser(features);
			parser.setViewPattern("{0}..{1}"); //$NON-NLS-1$
			parser.setEditorPattern("{0}..{1}"); //$NON-NLS-1$
			parser.setEditPattern("{0}..{1}"); //$NON-NLS-1$
			associationEdgeTargetLowerBoundTargetUpperBound_6010Parser = parser;
		}
		return associationEdgeTargetLowerBoundTargetUpperBound_6010Parser;
	}

	/**
	 * @generated
	 */
	protected IParser getParser(int visualID) {
		switch (visualID) {
		case BaseTypeNameEditPart.VISUAL_ID:
			return getBaseTypeName_5014Parser();
		case CollaborationNameEditPart.VISUAL_ID:
			return getCollaborationName_5018Parser();
		case AttributeNameTypeEditPart.VISUAL_ID:
			return getAttributeNameType_5012Parser();
		case MethodNameArgumentsReturnTypeEditPart.VISUAL_ID:
			return getMethodNameArgumentsReturnType_5013Parser();
		case RoleTypeNameEditPart.VISUAL_ID:
			return getRoleTypeName_5017Parser();
		case AttributeNameType2EditPart.VISUAL_ID:
			return getAttributeNameType_5015Parser();
		case MethodNameArgumentsReturnType2EditPart.VISUAL_ID:
			return getMethodNameArgumentsReturnType_5016Parser();
		case AssociationEdgeSourceNameEditPart.VISUAL_ID:
			return getAssociationEdgeSourceName_6007Parser();
		case AssociationEdgeSourceLowerBoundSourceUEditPart.VISUAL_ID:
			return getAssociationEdgeSourceLowerBoundSourceUpperBound_6008Parser();
		case AssociationEdgeTargetNameEditPart.VISUAL_ID:
			return getAssociationEdgeTargetName_6009Parser();
		case AssociationEdgeTargetLowerBoundTargetUEditPart.VISUAL_ID:
			return getAssociationEdgeTargetLowerBoundTargetUpperBound_6010Parser();
		}
		return null;
	}

	/**
	 * Utility method that consults ParserService
	 * @generated
	 */
	public static IParser getParser(IElementType type, EObject object,
			String parserHint) {
		return ParserService.getInstance().getParser(
				new HintAdapter(type, object, parserHint));
	}

	/**
	 * @generated
	 */
	public IParser getParser(IAdaptable hint) {
		String vid = (String) hint.getAdapter(String.class);
		if (vid != null) {
			return getParser(RoleVisualIDRegistry.getVisualID(vid));
		}
		View view = (View) hint.getAdapter(View.class);
		if (view != null) {
			return getParser(RoleVisualIDRegistry.getVisualID(view));
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean provides(IOperation operation) {
		if (operation instanceof GetParserOperation) {
			IAdaptable hint = ((GetParserOperation) operation).getHint();
			if (RoleElementTypes.getElement(hint) == null) {
				return false;
			}
			return getParser(hint) != null;
		}
		return false;
	}

	/**
	 * @generated
	 */
	private static class HintAdapter extends ParserHintAdapter {

		/**
		 * @generated
		 */
		private final IElementType elementType;

		/**
		 * @generated
		 */
		public HintAdapter(IElementType type, EObject object, String parserHint) {
			super(object, parserHint);
			assert type != null;
			elementType = type;
		}

		/**
		 * @generated
		 */
		public Object getAdapter(Class adapter) {
			if (IElementType.class.equals(adapter)) {
				return elementType;
			}
			return super.getAdapter(adapter);
		}
	}

}
