/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package net.core.editor.roles.impl;

import java.util.Collection;

import net.core.editor.roles.BaseType;
import net.core.editor.roles.Collaboration;
import net.core.editor.roles.Edge;
import net.core.editor.roles.RoleModel;
import net.core.editor.roles.RoleModelPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Role Model</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link net.core.editor.roles.impl.RoleModelImpl#getName <em>Name</em>}</li>
 *   <li>{@link net.core.editor.roles.impl.RoleModelImpl#getBaseTypes <em>Base Types</em>}</li>
 *   <li>{@link net.core.editor.roles.impl.RoleModelImpl#getEdges <em>Edges</em>}</li>
 *   <li>{@link net.core.editor.roles.impl.RoleModelImpl#getCollaborations <em>Collaborations</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RoleModelImpl extends EObjectImpl implements RoleModel {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getBaseTypes() <em>Base Types</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBaseTypes()
	 * @generated
	 * @ordered
	 */
	protected EList<BaseType> baseTypes;

	/**
	 * The cached value of the '{@link #getEdges() <em>Edges</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEdges()
	 * @generated
	 * @ordered
	 */
	protected EList<Edge> edges;

	/**
	 * The cached value of the '{@link #getCollaborations() <em>Collaborations</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCollaborations()
	 * @generated
	 * @ordered
	 */
	protected EList<Collaboration> collaborations;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RoleModelImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RoleModelPackage.Literals.ROLE_MODEL;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RoleModelPackage.ROLE_MODEL__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<BaseType> getBaseTypes() {
		if (baseTypes == null) {
			baseTypes = new EObjectContainmentEList<BaseType>(BaseType.class, this, RoleModelPackage.ROLE_MODEL__BASE_TYPES);
		}
		return baseTypes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Edge> getEdges() {
		if (edges == null) {
			edges = new EObjectContainmentEList<Edge>(Edge.class, this, RoleModelPackage.ROLE_MODEL__EDGES);
		}
		return edges;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Collaboration> getCollaborations() {
		if (collaborations == null) {
			collaborations = new EObjectContainmentEList<Collaboration>(Collaboration.class, this, RoleModelPackage.ROLE_MODEL__COLLABORATIONS);
		}
		return collaborations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RoleModelPackage.ROLE_MODEL__BASE_TYPES:
				return ((InternalEList<?>)getBaseTypes()).basicRemove(otherEnd, msgs);
			case RoleModelPackage.ROLE_MODEL__EDGES:
				return ((InternalEList<?>)getEdges()).basicRemove(otherEnd, msgs);
			case RoleModelPackage.ROLE_MODEL__COLLABORATIONS:
				return ((InternalEList<?>)getCollaborations()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RoleModelPackage.ROLE_MODEL__NAME:
				return getName();
			case RoleModelPackage.ROLE_MODEL__BASE_TYPES:
				return getBaseTypes();
			case RoleModelPackage.ROLE_MODEL__EDGES:
				return getEdges();
			case RoleModelPackage.ROLE_MODEL__COLLABORATIONS:
				return getCollaborations();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RoleModelPackage.ROLE_MODEL__NAME:
				setName((String)newValue);
				return;
			case RoleModelPackage.ROLE_MODEL__BASE_TYPES:
				getBaseTypes().clear();
				getBaseTypes().addAll((Collection<? extends BaseType>)newValue);
				return;
			case RoleModelPackage.ROLE_MODEL__EDGES:
				getEdges().clear();
				getEdges().addAll((Collection<? extends Edge>)newValue);
				return;
			case RoleModelPackage.ROLE_MODEL__COLLABORATIONS:
				getCollaborations().clear();
				getCollaborations().addAll((Collection<? extends Collaboration>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RoleModelPackage.ROLE_MODEL__NAME:
				setName(NAME_EDEFAULT);
				return;
			case RoleModelPackage.ROLE_MODEL__BASE_TYPES:
				getBaseTypes().clear();
				return;
			case RoleModelPackage.ROLE_MODEL__EDGES:
				getEdges().clear();
				return;
			case RoleModelPackage.ROLE_MODEL__COLLABORATIONS:
				getCollaborations().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RoleModelPackage.ROLE_MODEL__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case RoleModelPackage.ROLE_MODEL__BASE_TYPES:
				return baseTypes != null && !baseTypes.isEmpty();
			case RoleModelPackage.ROLE_MODEL__EDGES:
				return edges != null && !edges.isEmpty();
			case RoleModelPackage.ROLE_MODEL__COLLABORATIONS:
				return collaborations != null && !collaborations.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //RoleModelImpl
